#define AROS_ALMOST_COMPATIBLE
#include "mui.h"
#include "init.h"
#include "net.h"
#include "ix.h"
#include "copyright.h"
#include "rev.h"
#include "rbf.h"

#include <string.h>

#include <exec/rawfmt.h>
#include <libraries/commodities.h>

#include <workbench/startup.h>

#include <proto/commodities.h>
#include <proto/cybergraphics.h>
#include <devices/rawkeycodes.h>
#include <proto/icon.h>
#include <proto/dos.h>

#include <mui/Rawimage_mcc.h>
#include <mui/Aboutbox_mcc.h>

#define NEW_CATCOMP_ARRAY_IDS
#define CATCOMP_ARRAY
#include "zvnc_strings.h"

#include "gfx.h"

#define DISPATCHERNAME_BEGIN(Name)			\
ULONG Name(void) { Class *cl=(Class*) REG_A0; Msg msg=(Msg) REG_A1; Object *obj=(Object*) REG_A2; switch (msg->MethodID) {

#define DISPATCHER_END } return DoSuperMethodA(cl,obj,msg);}

#define DISPATCHER_GATE(Name) struct EmulLibEntry _Dispatcher_##Name = { TRAP_LIB, 0, (void (*)(void)) Name };

#define ZVNCBASE 5000

#define SERVERLIST_OBJECTID 1
#define TOGGLEKEY_OBJECTID  2
#define QUICKKEY_OBJECTID  3
#define DISCONNECTKEY_OBJECTID  4

#define DEBUG_APP(x)
#define DEBUG_HK(x) 

#define LS(_x) (CatCompArray[_x##_ID].cca_Str)

#define MENU_QUIT        -1
#define MENU_DISCONNECT  -2
#define MENU_SETTINGS    -3
#define MENU_SERVERLIST  -4
#define MENU_ABOUT       -5

char verstr[] = "$VER: "APPNAME" "VERTAG" "COPYRIGHT;

struct SLEntry
{
	char Host[1024];
	int  Screen;
	char Pass[256];
};

struct MUIData
{
	Object *App;
	Object *W_Settings;
	Object *W_Abox;
	Object *L_Servers;
	Object *K_ToggleKey;
	Object *K_QuickKey;
	Object *K_DisconnectKey;
	Object *T_Main;
	
	APTR Icon;

	Object *Slave;
	struct Task *SlaveTask;

	struct MUI_CustomClass *SBar;
	struct MUI_CustomClass *AppCl;
	struct MUI_CustomClass *SLCl;
	struct MUI_CustomClass *KACl;

	CxObj *hkToggle;
	CxObj *hkDisconnect;
	CxObj *hkQuickConnect;

	// some special states, might be read by the sbar
	struct SLEntry *Connection;
	BOOL connected;
	BOOL active;
	BOOL reconnecting;

	// specific to the sbar, remember there can be multiple instances of it!
	struct Task *SigTask;
	ULONG        sigbit;

	struct SignalSemaphore sbLock;
	/* start of sbLock data */
	char         HostName[1024];
	char         HotKey[128];
	Object      *Menustrip;
	Object      *MenustripCaller;
	struct List  SBObjects;
	/* end of sbLock data */	
};

STRPTR __programname;

static struct MUIData mdata;

static inline void SyncSbar(void)
{
	if (mdata.SigTask)
	{
		Signal(mdata.SigTask, 1L << mdata.sigbit);
	}
}

#define MUIM_ZVNCA_Connect (TAG_USER + 1)
#define MUIM_ZVNCA_Connected (TAG_USER + 2)
#define MUIM_ZVNCA_SetupHotkeys (TAG_USER + 3)
#define MUIM_ZVNCA_Menu (TAG_USER + 4)
#define MUIM_ZVNCA_MenuPick (TAG_USER + 5)

struct MUIP_ZVNCA_Connect {ULONG id; struct SLEntry *entry; };
struct MUIP_ZVNCA_MenuPick {ULONG id; LONG pick; };
struct MUIP_ZVNCA_Menu {ULONG id; Object *caller; };

// slave methods
#define MUIM_ZVNCA_Slave_Connect    (TAG_USER + 100)
#define MUIM_ZVNCA_Slave_Disconnect (TAG_USER + 101)
#define MUIM_ZVNCA_Slave_RawMouse   (TAG_USER + 102)
#define MUIM_ZVNCA_Slave_RawKey     (TAG_USER + 103)

#define MUIM_ZVNCA_Slave_Toggle     (TAG_USER + 104)

struct MUIP_ZVNCA_Slave_Connect {ULONG id; struct SLEntry *entry; };
struct MUIP_ZVNCA_Slave_RawMouse {ULONG id; ULONG class; ULONG subclass; ULONG code; ULONG qualifier; LONG x; LONG y;};
struct MUIP_ZVNCA_Slave_RawKey {ULONG id; ULONG class; ULONG subclass; ULONG code; ULONG qualifier; APTR eaddress; };

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

struct Data 
{
	struct MUI_EventHandlerNode eh;
	struct MUI_InputHandlerNode ih;

	BOOL ihadded;

	BOOL connected;
	BOOL active;
	BOOL reconnecting;

	APTR bubble;	

	struct Node node;
};

#define MUIM_ZVNC_Trigger (TAG_USER + 1)

ULONG ZVNC_New(struct IClass *cl,Object *obj,struct opSet *msg)
{
	obj = DoSuperNew(cl,obj,
					 MUIA_FillArea,FALSE,
					 TAG_MORE,msg->ops_AttrList);

	if (obj)
	{
		struct Data *data = INST_DATA(cl,obj);

		data->node.ln_Name = (char *)obj;

		ObtainSemaphore(&mdata.sbLock);
		ADDTAIL(&mdata.SBObjects, &data->node);
		ReleaseSemaphore(&mdata.sbLock);
		
	}

	return (ULONG)obj;
}

ULONG ZVNC_Dispose(struct IClass *cl, Object *obj, Msg msg)
{
	struct Data *data = INST_DATA(cl,obj);

	ObtainSemaphore(&mdata.sbLock);
	REMOVE(&data->node);
	ReleaseSemaphore(&mdata.sbLock);
	
	return DoSuperMethodA(cl, obj, msg);
}

static ULONG ZVNC_Get(struct IClass *cl, Object *obj, struct opGet *msg)
{
	switch (msg->opg_AttrID)
	{
	case MUIA_Screenbar_DisplayedName:
		*msg->opg_Storage = (IPTR)LS(MSG_SBAR_NAME);
		return TRUE;

	case MUIA_Screenbar_DisplayedImage:
		*msg->opg_Storage = (IPTR)RawimageObject, MUIA_Rawimage_Data, zvnc_list, End;
		return TRUE;
	}

	return DoSuperMethodA(cl, obj, msg);
}

static ULONG ZVNC_Setup(struct IClass *cl,Object *obj,Msg msg)
{
	struct Data *data = INST_DATA(cl,obj);
	ULONG rc = DoSuperMethodA(cl,obj,msg);

	if (rc)
	{
		data->eh.ehn_Priority = 0;
		data->eh.ehn_Flags = 0;
		data->eh.ehn_Events = IDCMP_MOUSEBUTTONS;
		data->eh.ehn_Object = obj;
		data->eh.ehn_Class = NULL;
		DoMethod(_win(obj),MUIM_Window_AddEventHandler,(ULONG)&data->eh);
		
		data->ih.ihn_Object = obj;
		data->ih.ihn_Millis = 50;
		data->ih.ihn_Flags = MUIIHNF_TIMER | MUIIHNF_TIMER_SCALE100;
		data->ih.ihn_Method = MUIM_ZVNC_Trigger;
		
		// note the sigtask once obtained is always valid
		if (mdata.SigTask == NULL)
		{
			get(_screen(obj), SA_ScreenbarSignal, &mdata.sigbit);
			mdata.SigTask = FindTask(0);
		}
	}

	return rc;
}

static ULONG ZVNC_Cleanup(struct IClass *cl,Object *obj,Msg msg)
{
	struct Data *data = INST_DATA(cl,obj);

	if (data->bubble) DoMethod(obj, MUIM_DeleteBubble, data->bubble);
	data->bubble = NULL;

	if (data->ihadded) DoMethod(_app(obj), MUIM_Application_RemInputHandler, &data->ih);
	data->ihadded = FALSE;

	DoMethod(_win(obj),MUIM_Window_RemEventHandler,(ULONG)&data->eh);

	return DoSuperMethodA(cl,obj,msg);
}

static ULONG ZVNC_AskMinMax(struct IClass *cl,Object *obj,struct MUIP_AskMinMax *msg)
{
	ULONG rc = DoSuperMethodA(cl,obj,msg);
	struct MUI_MinMax *mm = msg->MinMaxInfo;
	ULONG d = 8;

	get(_screen(obj), SA_Depth, &d);

	if (d > 8)
	{
		mm->MinWidth = mm->DefWidth = mm->MaxWidth = ZVNC_CONN_WIDTH + 2;
	}
	else
	{
		mm->MinWidth = mm->DefWidth = mm->MaxWidth = TextLength(_rp(obj), "ZVNC", 4) + 2;
	}
	
	mm->MinHeight = mm->DefHeight = mm->MaxHeight = _screen(obj)->BarHeight + 1;

	return rc;
}

static ULONG ZVNC_Draw(struct IClass *cl,Object *obj,struct MUIP_Draw *msg)
{
	struct Data *data = INST_DATA(cl,obj);
	ULONG rc = DoSuperMethodA(cl,obj,msg);
	ULONG d = 8;

	get(_screen(obj), SA_Depth, &d);

	if (d > 8)
	{
		APTR bmap = zvnc_disconn;
		
		if (data->reconnecting)
			bmap = zvnc_reconn;
		else if (data->active)
			bmap = zvnc_conn;
		else if (data->connected)
			bmap = zvnc_conn_not_lock;
		
		WritePixelArrayAlpha(bmap, 0, 0, ZVNC_CONN_WIDTH * 4, _rp(obj), _mleft(obj) + 1, _mtop(obj) + (_mheight(obj) / 2) - (ZVNC_CONN_HEIGHT / 2),
			ZVNC_CONN_WIDTH, ZVNC_CONN_HEIGHT, 0xFFFFFFFF);
	}
	else
	{
		struct RastPort rp;
		struct TextFont *f = NULL;
		LONG to, p;

		memcpy(&rp, _rp(obj), sizeof (rp));
		
		get(_screen(obj), SA_ScreenbarTextYPos, &to);
		get(_screen(obj), SA_ScreenbarTextFont, &f);
		get(_screen(obj), SA_ScreenbarTextPen, &p);
		
		SetFont(&rp, f);
		SetABPenDrMd(&rp, p, 0, JAM1);
	
		Move(&rp, _mleft(obj) + 1, _mtop(obj) + to);
		Text(&rp, "ZVNC", 4);
	}
	
	return rc;
}

static ULONG ZVNC_Signal(struct IClass *cl, Object *obj)
{
	struct Data *data = INST_DATA(cl, obj);

	BOOL connected = mdata.connected;
	BOOL active = mdata.active;
	BOOL reconnecting = mdata.reconnecting;

	if (connected != data->connected ||
		active != data->active ||
		reconnecting != data->reconnecting)
	{
		STRPTR bubbie = NULL;
		ULONG bl = 0;

		data->active = active;
		data->reconnecting = reconnecting;
		data->connected = connected;
	
		MUI_Redraw(obj, MADF_DRAWOBJECT);

		if (data->reconnecting)
		{
			ObtainSemaphoreShared(&mdata.sbLock);
			NewRawDoFmt(LS(MSG_BUBBLE_RECONNECTING), (APTR)RAWFMTFUNC_COUNT, (STRPTR)&bl, mdata.HostName);
			if (bl > 0)
			{
				bubbie = AllocVec(bl + 1, MEMF_PUBLIC);
				if (bubbie)
				{
					NewRawDoFmt(LS(MSG_BUBBLE_RECONNECTING), RAWFMTFUNC_STRING, bubbie, mdata.HostName);
				}
			}
			ReleaseSemaphore(&mdata.sbLock);
		}
		else if (data->connected)
		{
			if (data->active)
			{
				ObtainSemaphoreShared(&mdata.sbLock);
				NewRawDoFmt(LS(MSG_BUBBLE_CONNECTED), (APTR)RAWFMTFUNC_COUNT, (STRPTR)&bl, mdata.HostName, mdata.HotKey);
				if (bl > 0)
				{
					bubbie = AllocVec(bl + 1, MEMF_PUBLIC);
					if (bubbie)
					{
						NewRawDoFmt(LS(MSG_BUBBLE_CONNECTED), RAWFMTFUNC_STRING, bubbie, mdata.HostName, mdata.HotKey);
					}
				}
				ReleaseSemaphore(&mdata.sbLock);
			}
			else
			{
				ObtainSemaphoreShared(&mdata.sbLock);
				NewRawDoFmt(LS(MSG_BUBBLE_DEACTIVATED), (APTR)RAWFMTFUNC_COUNT, (STRPTR)&bl, mdata.HotKey);
				if (bl > 0)
				{
					bubbie = AllocVec(bl + 1, MEMF_PUBLIC);
					if (bubbie)
					{
						NewRawDoFmt(LS(MSG_BUBBLE_DEACTIVATED), RAWFMTFUNC_STRING, bubbie, mdata.HotKey);
					}
				}
				ReleaseSemaphore(&mdata.sbLock);
			
				if (!data->ihadded)
				{
					DoMethod(_app(obj), MUIM_Application_AddInputHandler, (IPTR)&data->ih);
					data->ihadded = TRUE;
				}
			}
		}
		
		if (data->bubble) DoMethod(obj, MUIM_DeleteBubble, data->bubble);
		if (bubbie)
		{
			data->bubble = (APTR)DoMethod(obj, MUIM_CreateBubble, _mleft(obj), _mbottom(obj), bubbie, 0);
			FreeVec(bubbie);
		}
		else
		{
			data->bubble = NULL;
		}
	}
	else if (mdata.Menustrip)
	{
		Object *ms, *caller = NULL;
		struct Node *n;
		
		ObtainSemaphore(&mdata.sbLock);
		
		ms = mdata.Menustrip;
		mdata.Menustrip = NULL;

		// ensure still valid object... could have been disposed in the meanwhile
		ForeachNode(&mdata.SBObjects, n)
		{
			if (mdata.MenustripCaller == (APTR)n->ln_Name)
			{
				caller = mdata.MenustripCaller;
				break;				
			}
		}
		
		mdata.MenustripCaller = NULL;
		ReleaseSemaphore(&mdata.sbLock);
		
		if (ms)
		{
			ULONG rc = DoMethod(ms, MUIM_Menustrip_Popup, caller, 0, _left(obj), _bottom(obj));
			
			DoMethod(mdata.Slave, MUIM_Slave_Dispatch, 0, 2, MUIM_ZVNCA_MenuPick, rc);
			
			MUI_DisposeObject(ms);
		}
	}

	return TRUE;
}

// some helper macros
#define _between(a,x,b) ((x)>=(a) && (x)<=(b))
#define _isinobject(x,y) (_between(_mleft(obj),(x),_mright (obj)) \
						   && _between(_mtop(obj) ,(y),_mbottom(obj)))

static ULONG ZVNC_HandleEvent(struct IClass *cl,Object *obj,struct MUIP_HandleEvent *msg)
{
//	struct Data *data = INST_DATA(cl,obj);
	
	if (msg->imsg != NULL)
	{
		switch (msg->imsg->Class)
		{
			case IDCMP_MOUSEBUTTONS:
				if (msg->imsg->Code == SELECTUP)
				{
					if (_isinobject(msg->imsg->MouseX,msg->imsg->MouseY))
					{
						DoMethod(mdata.Slave, MUIM_Slave_Dispatch, 0, 2, MUIM_ZVNCA_Menu, obj);
						return MUI_EventHandlerRC_Eat;
					}
				}
				break;
		}
	}

	return 0;
}

static IPTR ZVNC_BuildSettingsPanel(struct IClass *cl,Object *obj,struct MUIP_Screenbar_BuildSettingsPanel *msg)
{
	return (IPTR)MUI_NewObject(MUIC_Mccprefs,
		Child, VSpace(0),
		Child, TextObject,
			MUIA_Text_Contents, LS(MSG_SBAR_NAME),
			MUIA_Frame,         MUIV_Frame_Text,
			MUIA_Background,    MUII_TextBack,
			MUIA_FixHeightTxt,  "\n",
		End,
		TAG_DONE);
}

static IPTR ZVNC_Trigger(struct IClass *cl, Object *obj)
{
	struct Data *data = INST_DATA(cl, obj);

	if (data->bubble)
	{
		if (data->ihadded) DoMethod(_app(obj), MUIM_Application_RemInputHandler, &data->ih);
		DoMethod(obj, MUIM_DeleteBubble, data->bubble);
		data->bubble = NULL;
		data->ihadded = FALSE;
	}
	
	return 0;
}

DISPATCHERNAME_BEGIN(ZVNC_Sbar)
	case OM_NEW:                               return ZVNC_New(cl,obj,(APTR)msg);
	case OM_DISPOSE:                           return ZVNC_Dispose(cl,obj,(APTR)msg);
	case OM_GET:                               return ZVNC_Get(cl, obj, (APTR)msg);
	case MUIM_Setup:                           return ZVNC_Setup(cl,obj,(APTR)msg);
	case MUIM_Cleanup:                         return ZVNC_Cleanup(cl,obj,(APTR)msg);
	case MUIM_AskMinMax:                       return ZVNC_AskMinMax(cl,obj,(APTR)msg);
	case MUIM_Draw:                            return ZVNC_Draw(cl,obj,(APTR)msg);
	case MUIM_HandleEvent:                     return ZVNC_HandleEvent(cl,obj,(APTR)msg);
	case MUIM_Screenbar_BuildSettingsPanel:    return ZVNC_BuildSettingsPanel(cl,obj,(APTR)msg);
	case MUIM_Screenbar_Signal:                return ZVNC_Signal(cl, obj);
	case MUIM_ZVNC_Trigger:                    return ZVNC_Trigger(cl, obj);
DISPATCHER_END
DISPATCHER_GATE(ZVNC_Sbar)

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

#ifndef MUIM_List_EditEntry
#define MUIM_List_EditEntry                 0x804236a5 /* private */ /* V20 */
#define MUIM_List_EditStop                  0x8042ce3a /* private */ /* V20 */
struct  MUIP_List_EditStop                  { ULONG MethodID; LONG pos; APTR editdata; LONG muikey; };
#endif

struct SLData
{
	ULONG RC;
};

#define MUIM_ZVNCSL_DoubleClick (TAG_USER + 1)

struct SLConfigEntry
{
	LONG           NumEntries;
	struct SLEntry Entries[1];
};

IPTR ZVNCSL_New(struct IClass *cl, Object *obj, struct opSet *msg)
{
	obj = DoSuperNew(cl, obj,
		InputListFrame,
		MUIA_List_Title, TRUE,
		MUIA_List_Format, "MIW=50 BAR, MIW=10 BAR, MIW=30 BAR",
		MUIA_List_DragSortable, TRUE,
		MUIA_List_DragType, MUIV_List_DragType_Immediate,
		MUIA_List_ShowDropMarks, TRUE,
		TAG_MORE, msg->ops_AttrList);
		
	if (obj)
	{
		DoMethod(obj, MUIM_Notify, MUIA_List_DoubleClick, MUIV_EveryTime, obj, 1, MUIM_ZVNCSL_DoubleClick);
	}
		
	return (IPTR)obj;
}

IPTR ZVNCSL_Import(struct IClass *cl, Object *obj, struct MUIP_Import *msg)
{
	struct SLConfigEntry *ce;
	
	set(obj, MUIA_List_Quiet, TRUE);
	
	DoMethod(obj, MUIM_List_Clear);
	
	if ((ce = (struct SLConfigEntry *)DoMethod(msg->dataspace, MUIM_Dataspace_Find, SERVERLIST_OBJECTID)))
	{
		// some reasonable limits to validate input more or less...
		if (ce->NumEntries > 0 && ce->NumEntries < 2048)
		{
			int i;
			for (i = 0; i < ce->NumEntries; i++)
			{
				DoMethod(obj, MUIM_List_InsertSingle, &ce->Entries[i], MUIV_List_Insert_Bottom);
			}
		}
	}
	
	set(obj, MUIA_List_Quiet, FALSE);

	return 0;
}

IPTR ZVNCSL_Export(struct IClass *cl, Object *obj, struct MUIP_Export *msg)
{
	struct SLConfigEntry *ce = NULL;
	ULONG e = 0;
	
	get(obj, MUIA_List_Entries, &e);
	
	if (e > 0 && e < 2048)
	{
		ULONG cesize = sizeof (struct SLConfigEntry) + (sizeof (struct SLEntry) * (e - 1));
		ce = AllocMem(cesize, MEMF_PUBLIC);
		
		if (ce)
		{
			int i;
			
			ce->NumEntries = e;
			
			for (i = 0; i < e; i++)
			{
				struct SLEntry *se = NULL;
				
				DoMethod(obj, MUIM_List_GetEntry, i, (IPTR)&se);
				
				if (se)
				{
					memcpy(&ce->Entries[i], se, sizeof (struct SLEntry));
				}
				else
				{
					ce->Entries[i].Host[0] = 0;
					ce->Entries[i].Screen = 5900;
					ce->Entries[i].Pass[0] = 0;
				}
			}
			
			DoMethod(msg->dataspace, MUIM_Dataspace_Add, (IPTR)ce, cesize, SERVERLIST_OBJECTID);
			
			FreeMem(ce, cesize);
		}
	}
	
	return 0;
}

IPTR ZVNCSL_Construct(struct IClass *cl, Object *obj, struct MUIP_List_Construct *msg)
{
	struct SLEntry *e = AllocPooled(msg->pool, sizeof (struct SLEntry));
	
	if (e)
	{
		if (msg->entry == (APTR)1)
		{
			e->Host[0] = 0;
			e->Screen = 5900;
			e->Pass[0] = 0;
		}
		else if (msg->entry)
		{
			memcpy(e, msg->entry, sizeof (struct SLEntry));
		}
	}

	return (IPTR)e;
};

IPTR ZVNCSL_Destruct(struct IClass *cl, Object *obj, struct MUIP_List_Destruct *msg)
{
	FreePooled(msg->pool, msg->entry, sizeof (struct SLEntry));
	return 0;
};

IPTR ZVNCSL_Display(struct IClass *cl, Object *obj, struct MUIP_List_Display *msg)
{
	DoSuperMethodA(cl, obj, msg);

	if (msg->entry)
	{
		static char sb[12];
		struct SLEntry *e = (struct SLEntry *)msg->entry;
		msg->array[0] = e->Host;
		NewRawDoFmt("%ld", RAWFMTFUNC_STRING, sb, e->Screen);
		msg->array[1] = sb;
		msg->array[2] = e->Pass[0] ? "******" : "";
	}
	else
	{
		msg->array[0] = LS(MSG_LIST_HOST);
		msg->array[1] = LS(MSG_LIST_PORT);
		msg->array[2] = LS(MSG_LIST_PASSWORD);
	}

	return 0;
};

IPTR ZVNCSL_DoubleClick(struct IClass *cl, Object *obj)
{
	struct SLData *data = INST_DATA(cl, obj);
	struct SLEntry *e = NULL;
	ULONG cc = -1;
	
	DoMethod(obj, MUIM_List_GetEntry, MUIV_List_GetEntry_Active, &e);
	
	get(obj, MUIA_List_ClickColumn, &cc);
	
	if (e)
	{
		data->RC = cc;

		switch (cc)
		{
			case 0:
				DoMethod(obj, MUIM_List_EditEntry, -1, e->Host, 0);
				break;

			case 1:
				{
					static char sb[12];
					NewRawDoFmt("%ld", RAWFMTFUNC_STRING, sb, e->Screen);
					DoMethod(obj, MUIM_List_EditEntry, -1, sb, 1);
				}
				break;

			case 2:
				DoMethod(obj, MUIM_List_EditEntry, -1, "", 2);
				break;
		}
	}
	
	return 0;
};

IPTR ZVNCSL_EditStop(struct IClass *cl, Object *obj, struct MUIP_List_EditStop *msg)
{
	struct SLData *data = INST_DATA(cl, obj);
	struct SLEntry *e = NULL;

	IPTR rc = DoSuperMethodA(cl, obj, msg);
	
	DoMethod(obj, MUIM_List_GetEntry, MUIV_List_GetEntry_Active, &e);
	
	if (e && msg->editdata)
	{
		switch (data->RC)
		{
		case 0:
			stccpy(e->Host, msg->editdata, sizeof (e->Host));
			break;
			
		case 1:
			e->Screen = atoi(msg->editdata);
			break;
			
		case 2:
			stccpy(e->Pass, msg->editdata, sizeof (e->Pass));
			break;
		}
	}
	
	return rc;
};

DISPATCHERNAME_BEGIN(ZVNC_ServerList)
	case OM_NEW:                               return ZVNCSL_New(cl, obj, (APTR)msg);
	case MUIM_Import:                          return ZVNCSL_Import(cl, obj, (APTR)msg);
	case MUIM_Export:                          return ZVNCSL_Export(cl, obj, (APTR)msg);
	case MUIM_List_Construct:                  return ZVNCSL_Construct(cl, obj, (APTR)msg);
	case MUIM_List_Destruct:                   return ZVNCSL_Destruct(cl, obj, (APTR)msg);
	case MUIM_List_Display:                    return ZVNCSL_Display(cl, obj, (APTR)msg);
	case MUIM_List_EditStop:                   return ZVNCSL_EditStop(cl, obj, (APTR)msg);
	case MUIM_ZVNCSL_DoubleClick:              return ZVNCSL_DoubleClick(cl, obj);
DISPATCHER_END
DISPATCHER_GATE(ZVNC_ServerList)

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

struct KAData
{
	ULONG dummy;
};

IPTR ZVNCKA_Import(struct IClass *cl, Object *obj, struct MUIP_Import *msg)
{
	STRPTR hk;
	IPTR oid;
	
	get(obj, MUIA_ObjectID, &oid);
	
	hk = (STRPTR)DoMethod(msg->dataspace, MUIM_Dataspace_Find, oid);
	
	if (hk) set(obj, MUIA_Keyadjust_Key, hk);
	
	return 0;
}

IPTR ZVNCKA_Export(struct IClass *cl, Object *obj, struct MUIP_Export *msg)
{
	STRPTR hk = 0;
	IPTR oid;
	
	get(obj, MUIA_ObjectID, &oid);
	get(obj, MUIA_Keyadjust_Key, &hk);

	if (hk && oid)
		DoMethod(msg->dataspace, MUIM_Dataspace_Add, (IPTR)hk, strlen(hk) + 1, oid);

	return 0;
}

DISPATCHERNAME_BEGIN(ZVNC_Keyadjust)
	case MUIM_Import:                          return ZVNCKA_Import(cl, obj, (APTR)msg);
	case MUIM_Export:                          return ZVNCKA_Export(cl, obj, (APTR)msg);
DISPATCHER_END
DISPATCHER_GATE(ZVNC_Keyadjust)

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

struct AData
{
	ULONG dummy;
};

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

/*
 * Warnings! This is run on input.device's context.
 * No dos.library or intuition functions. Minimal
 * stack usage. Should be very quick.
 */
void cxfunction(void);
extern CxObj *custom;

struct EmulLibEntry GATE_cxfunction = {
	TRAP_LIB, 0, (void (*)(void))cxfunction
};

void cxfunction(void)
{
	CxMsg *cxm = (CxMsg *)REG_A0;
	struct InputEvent *ie;
	
	ie = (struct InputEvent *)CxMsgData(cxm);

	switch (ie->ie_Class)
	{
		case IECLASS_RAWMOUSE: /* mousebuttons */
		case IECLASS_NEWPOINTERPOS: /* mouse movements */
		case IECLASS_NEWMOUSE: /* mouse wheel */
		case IECLASS_POINTERPOS:
			DoMethod(mdata.Slave, MUIM_Slave_Dispatch, MUIF_Slave_Delegate_ForceSlave, 7,
				MUIM_ZVNCA_Slave_RawMouse, (IPTR)ie->ie_Class, (IPTR)ie->ie_SubClass,
				(IPTR)ie->ie_Code, (IPTR)ie->ie_Qualifier, (IPTR)ie->ie_X, (IPTR)ie->ie_Y);
			DisposeCxMsg(cxm);
			break;
	
		case IECLASS_RAWKEY: /* keyboard */
			DoMethod(mdata.Slave, MUIM_Slave_Dispatch, MUIF_Slave_Delegate_ForceSlave, 6,
				MUIM_ZVNCA_Slave_RawKey, (IPTR)ie->ie_Class, (IPTR)ie->ie_SubClass,
				(IPTR)ie->ie_Code, (IPTR)ie->ie_Qualifier, (IPTR)ie->ie_EventAddress);
			DisposeCxMsg(cxm);
			break;
	}
}

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

IPTR ZVNCA_New(struct IClass *cl, Object *obj, struct opSet *msg)
{
	obj = DoSuperNew(cl, obj,
			MUIA_Application_Title, LS(MSG_APPLICATION_TITLE),
			MUIA_Application_Author, "David Gerber, Jacek Piszczek",
			MUIA_Application_Copyright, "(C)2001-2003 David Gerber, 2013 Jacek Piszczek",
			MUIA_Application_Description, LS(MSG_APPLICATION_DESCRIPTION),
			MUIA_Application_Base, "ZVNC",
			MUIA_Application_Version, verstr,
			MUIA_Application_UseCommodities, FALSE,
			MUIA_Application_UseRexx, FALSE,
			MUIA_Application_DiskObject, mdata.Icon = GetDiskObject(__programname),
			MUIA_Application_Menustrip,
				MenustripObject,
					Child, MenuObject,
						MUIA_Menu_Title, LS(MSG_MENU_PROJECT),
						Child, MenuitemObject,
							MUIA_Menuitem_Title, LS(MSG_MENU_ABOUT),
							MUIA_Menuitem_Shortcut, LS(MSG_MENU_ABOUT_KEY),
							MUIA_UserData, MENU_ABOUT,
							End,
						Child, MenuitemObject,
							MUIA_Menuitem_Title, LS(MSG_MENU_QUIT),
							MUIA_Menuitem_Shortcut, LS(MSG_MENU_QUIT_KEY),
							MUIA_UserData, MENU_QUIT,
							End,
						End,
					End,
			TAG_MORE, msg->ops_AttrList);
	
	if (obj)
	{
		DoMethod(obj, MUIM_Notify, MUIA_Application_MenuAction, MUIV_EveryTime, obj, 2, MUIM_ZVNCA_MenuPick, MUIV_TriggerValue);
	}
		
	return (IPTR)obj;
}

IPTR ZVNCA_Connect(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_Connect *msg)
{
	struct SLEntry *e = msg->entry;
	
	if (!e)
	{
		DoMethod(mdata.L_Servers, MUIM_List_GetEntry, MUIV_List_GetEntry_Active, &e);
	}
	
	if (e)
	{
		struct SLEntry *ecopy = AllocMem(sizeof (struct SLEntry), MEMF_PUBLIC);
		
		if (ecopy)
		{
			memcpy(ecopy, e, sizeof (struct SLEntry));
			
			if (!DoMethod(mdata.Slave, MUIM_ZVNCA_Slave_Connect, ecopy))
			{
				FreeMem(ecopy, sizeof (struct SLEntry));
			}
		}
	}
	
	return 0;
}

IPTR ZVNCA_Connected(struct IClass *cl, Object *obj)
{
	set(mdata.W_Settings, MUIA_Window_Open, FALSE);
	return 0;
}

IPTR ZVNCA_Menu(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_Menu *msg)
{
	// spawns a menu at given coords... this goes through the Slave but is always called on the gui Process!
	Object *m;
	Object *ms = MenustripObject, 
		Child, m = MenuObject,
			MUIA_Menu_Title, LS(MSG_CTXMENU_TITLE), End,
		End;

	if (ms)
	{
		ULONG ne = 0, i;
		
		get(mdata.L_Servers, MUIA_List_Entries, &ne);
		
		for (i = 0; i < ne; i++)
		{
			struct SLEntry *sle = NULL;
			
			DoMethod(mdata.L_Servers, MUIM_List_GetEntry, i, (IPTR)&sle);
			
			if (sle)
			{
				DoMethod(m, OM_ADDMEMBER, MenuitemObject,
					MUIA_Menuitem_Title, sle->Host, MUIA_UserData, i + 1, End);
			}
		}

		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, (IPTR)-1, End);
		
		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, LS(MSG_CTXMENU_SERVERLIST), MUIA_UserData, MENU_SERVERLIST, End);
		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, LS(MSG_CTXMENU_SETTINGS), MUIA_UserData, MENU_SETTINGS, End);

		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, (IPTR)-1, End);

		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, LS(MSG_CTXMENU_DISCONNECT), MUIA_UserData, MENU_DISCONNECT, End);
		DoMethod(m, OM_ADDMEMBER, MenuitemObject, MUIA_Menuitem_Title, LS(MSG_CTXMENU_QUIT), MUIA_UserData, MENU_QUIT, End);

		ObtainSemaphore(&mdata.sbLock);

		if (!mdata.Menustrip)
		{
			mdata.Menustrip = ms;
			mdata.MenustripCaller = msg->caller;
		}
		else
		{
			MUI_DisposeObject(ms);
		}

		ReleaseSemaphore(&mdata.sbLock);

		SyncSbar();
	}

	return 0;
}

IPTR ZVNCA_MenuPick(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_MenuPick *msg)
{
	if (msg->pick > 0)
	{
		struct SLEntry *sle = NULL;
		
		DoMethod(mdata.L_Servers, MUIM_List_GetEntry, msg->pick - 1, (IPTR)&sle);
		
		if (sle)
		{
			DoMethod(obj, MUIM_ZVNCA_Connect, sle);
		}
	}
	else
	{
		switch (msg->pick)
		{
		case MENU_QUIT:
			Signal(FindTask(0), SIGBREAKF_CTRL_C);
			break;
			
		case MENU_DISCONNECT:
			DoMethod(mdata.Slave, MUIM_Slave_Dispatch, MUIF_Slave_Delegate_ForceSlave, 1, MUIM_ZVNCA_Slave_Disconnect);
			break;
			
		case MENU_SERVERLIST:
			set(mdata.T_Main, MUIA_Group_ActivePage, 0);
			set(mdata.App, MUIA_Application_Iconified, FALSE);
			set(mdata.W_Settings, MUIA_Window_Open, TRUE);
			break;
			
		case MENU_SETTINGS:
			set(mdata.T_Main, MUIA_Group_ActivePage, 1);
			set(mdata.App, MUIA_Application_Iconified, FALSE);
			set(mdata.W_Settings, MUIA_Window_Open, TRUE);
			break;
			
		case MENU_ABOUT:
			if (!mdata.W_Abox)
			{
				mdata.W_Abox = AboutboxObject,
					End;
					
				if (mdata.W_Abox)
				{
					DoMethod(mdata.App, OM_ADDMEMBER, mdata.W_Abox);
				}
			}
			set(mdata.W_Abox, MUIA_Window_Open, TRUE);
			break;
		}
	}
	
	return 0;
}

IPTR ZVNCA_SetupHotkeys(struct IClass *cl, Object *obj)
{
	STRPTR s;
	
	if (mdata.hkDisconnect)
	{
		RemoveCxObj(mdata.hkDisconnect);
		DeleteCxObjAll(mdata.hkDisconnect);
	}
	
	if (mdata.hkQuickConnect)
	{
		RemoveCxObj(mdata.hkQuickConnect);
		DeleteCxObjAll(mdata.hkQuickConnect);
	}
	
	if (mdata.hkToggle)
	{
		RemoveCxObj(mdata.hkToggle);
		DeleteCxObjAll(mdata.hkToggle);
	}
	
	get(mdata.K_ToggleKey, MUIA_String_Contents, &s);
	mdata.hkToggle = bind_hotkey(s, EVT_CAPTURETOGGLE);
	if (mdata.hkToggle) AttachCxObj(broker, mdata.hkToggle);

	DEBUG_HK(dprintf("%s: toggle key %s %p\n", __FUNCTION__, s, mdata.hkToggle));

	ObtainSemaphore(&mdata.sbLock);
	if (s) stccpy(mdata.HotKey, s, sizeof (mdata.HotKey));
	ReleaseSemaphore(&mdata.sbLock);

	SyncSbar();

	get(mdata.K_QuickKey, MUIA_String_Contents, &s);
	mdata.hkQuickConnect = bind_hotkey(s, EVT_QUICKCONNECT);
	if (mdata.hkQuickConnect) AttachCxObj(broker, mdata.hkQuickConnect);

	get(mdata.K_DisconnectKey, MUIA_String_Contents, &s);
	mdata.hkDisconnect = bind_hotkey(s, EVT_DISCONNECT);
	if (mdata.hkDisconnect) AttachCxObj(broker, mdata.hkDisconnect);

	return 0;
}

void ZVNCA_Slave_ResetQualifiers(struct IClass *cl, Object *obj)
{
	DoMethod(obj, MUIM_ZVNCA_Slave_RawKey, IECLASS_RAWKEY, 0, RAWKEY_CONTROL, IEQUALIFIER_CONTROL, 0, 0);
	DoMethod(obj, MUIM_ZVNCA_Slave_RawKey, IECLASS_RAWKEY, 0, RAWKEY_CONTROL | IECODE_UP_PREFIX, 0, 0, 0);
}

IPTR ZVNCA_Slave_Connect(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_Slave_Connect *msg)
{
	if (mdata.connected)
	{
		rbf_cleanup();
		RemoveCxObj(custom);
		mdata.active = FALSE;
		SyncSbar();
	}
	
	DEBUG_APP(dprintf("%s: connect to %s/%ld\n", __FUNCTION__, msg->entry->Host, msg->entry->Screen));
	
	mdata.connected = rbf_init(msg->entry->Host, msg->entry->Screen, msg->entry->Pass);
	
	// make sure to dispose the data we no longer need...
	if (mdata.Connection)
		FreeMem(mdata.Connection, sizeof (struct SLEntry));
	mdata.Connection = NULL;
	
	if (mdata.connected)
	{
		DEBUG_APP(dprintf("%s: connected cbx %p broker %p custom %p!\n", __FUNCTION__, CxBase, broker, custom));

		// we need to be able to reconnect, so let's store the current data...
		mdata.Connection = msg->entry;
	
		// this is where we attach the cx broker to capture events...
		AttachCxObj(broker, custom);
		mdata.active = TRUE;

		DEBUG_APP(dprintf("%s: attached!\n", __FUNCTION__));
		
		ObtainSemaphore(&mdata.sbLock);
		stccpy(mdata.HostName, mdata.Connection->Host, sizeof (mdata.HostName));
		ReleaseSemaphore(&mdata.sbLock);
		
		// we also should notify the screenbar so that it displays an appropriate state...
		SyncSbar();
		
		// and finally we make sure the GUI is hidden...
		DoMethod(mdata.Slave, MUIM_Slave_Dispatch, 0, 1, MUIM_ZVNCA_Connected);

		// make sure this isn't stuck somehow...
		ZVNCA_Slave_ResetQualifiers(cl, obj);
	}
	else
	{
		FreeMem(msg->entry, sizeof (struct SLEntry));
	}

	return 0;
}

IPTR ZVNCA_Slave_Disconnect(struct IClass *cl, Object *obj)
{
	if (mdata.connected)
	{
		mdata.connected = FALSE;
		mdata.active = FALSE;

		RemoveCxObj(custom);

		SyncSbar();

		rbf_cleanup();

		if (mdata.Connection)
			FreeMem(mdata.Connection, sizeof (struct SLEntry));
		mdata.Connection = NULL;
	}
	
	return 0;
}

IPTR ZVNCA_Slave_RawMouse(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_Slave_RawMouse *msg)
{
	if (mdata.connected && mdata.active)
	{
		struct InputEvent ie;
		
		ie.ie_NextEvent = 0;
		ie.ie_Class = msg->class;
		ie.ie_SubClass = msg->subclass;
		ie.ie_Code = msg->code;
		ie.ie_Qualifier = msg->qualifier;
		ie.ie_X = msg->x;
		ie.ie_Y = msg->y;
		
		if (RBF_BROKENLINK == rbf_send_mouseevent(&ie))
		{
			mdata.reconnecting = TRUE;
			SyncSbar();
		
			RemoveCxObj(custom);
			rbf_cleanup();

			mdata.connected = rbf_init(mdata.Connection->Host, mdata.Connection->Screen, mdata.Connection->Pass);

			mdata.reconnecting = FALSE;

			if (mdata.connected)
			{
				if (mdata.active)
					AttachCxObj(broker, custom);
			}
			else
			{
				mdata.active = FALSE;
				rbf_cleanup();
			}

			SyncSbar();
		}
	}
	
	return 0;
}

IPTR ZVNCA_Slave_RawKey(struct IClass *cl, Object *obj, struct MUIP_ZVNCA_Slave_RawKey *msg)
{
	if (mdata.connected && mdata.active)
	{
		struct InputEvent ie;
		int r;
		
		ie.ie_NextEvent = 0;
		ie.ie_Class = msg->class;
		ie.ie_SubClass = msg->subclass;
		ie.ie_Code = msg->code;
		ie.ie_Qualifier = msg->qualifier;
		ie.ie_EventAddress = msg->eaddress;

		DEBUG_APP(dprintf("%s: rawkey code %lx subclass %lx qual %lx ea %p\n", __FUNCTION__,
			msg->code, msg->subclass, msg->qualifier, msg->eaddress));
		
		r = rbf_send_keyevent(&ie);
		
		if (r == RBF_BROKENLINK)
		{
			mdata.reconnecting = TRUE;
			SyncSbar();
	
			RemoveCxObj(custom);
			rbf_cleanup();

			mdata.connected = rbf_init(mdata.Connection->Host, mdata.Connection->Screen, mdata.Connection->Pass);

			mdata.reconnecting = FALSE;

			if (mdata.connected)
			{
				if (mdata.active)
					AttachCxObj(broker, custom);
			}
			else
			{
				rbf_cleanup();
				mdata.active = FALSE;
			}

			SyncSbar();
		}
		else if (r == RBF_QUIT)
		{
			DoMethod(obj, MUIM_ZVNCA_Slave_Disconnect);
		}
	}

	return 0;
}

IPTR ZVNCA_Slave_Toggle(struct IClass *cl, Object *obj)
{
	mdata.active = !mdata.active;

	if (mdata.connected)
	{
		SyncSbar();

		if (mdata.active)
		{
			AttachCxObj(broker, custom);

			// make sure this isn't stuck somehow...
			ZVNCA_Slave_ResetQualifiers(cl, obj);
		}
		else
		{
			RemoveCxObj(custom);
			ZVNCA_Slave_ResetQualifiers(cl, obj);
		}
	}

	return 0;
}

IPTR ZVNCA_Slave_Setup(struct IClass *cl, Object *obj)
{
	DEBUG_APP(dprintf("%s: setting up the slave!\n", __FUNCTION__));

	mdata.SlaveTask = FindTask(0);

	tcp_earlyinit();
	
	return TRUE;
}

IPTR ZVNCA_Slave_Cleanup(struct IClass *cl, Object *obj)
{
	DEBUG_APP(dprintf("%s: cleaning up the slave!\n", __FUNCTION__));

	mdata.SlaveTask = NULL;

	RemoveCxObj(custom);
	
	if (mdata.Connection)
		FreeMem(mdata.Connection, sizeof (struct SLEntry));

	mdata.Connection = NULL;

	SyncSbar();

	rbf_cleanup();
	tcp_latecleanup();

	return TRUE;
}

IPTR ZVNCA_Slave_Error(struct IClass *cl, Object *obj, struct MUIP_Slave_Error *msg)
{
	switch (msg->FailedDispatch->MethodID)
	{
	case MUIM_ZVNCA_Slave_Connect:
		{
			struct MUIP_ZVNCA_Slave_Connect *smsg = (struct MUIP_ZVNCA_Slave_Connect *)msg->FailedDispatch;
			FreeMem(smsg->entry, sizeof (struct SLEntry));
		}
		break;
	}
	
	return TRUE;
}

DISPATCHERNAME_BEGIN(ZVNC_App)
	case OM_NEW:                               return ZVNCA_New(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_Connect:                   return ZVNCA_Connect(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_Connected:                 return ZVNCA_Connected(cl, obj);
	case MUIM_ZVNCA_Menu:                      return ZVNCA_Menu(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_MenuPick:                  return ZVNCA_MenuPick(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_SetupHotkeys:              return ZVNCA_SetupHotkeys(cl, obj);
	case MUIM_Slave_Error:                     return ZVNCA_Slave_Error(cl, obj, (APTR)msg);
	case MUIM_Slave_Setup:                     return ZVNCA_Slave_Setup(cl, obj);
	case MUIM_Slave_Cleanup:                   return ZVNCA_Slave_Cleanup(cl, obj);
	case MUIM_ZVNCA_Slave_Connect:             return ZVNCA_Slave_Connect(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_Slave_Disconnect:          return ZVNCA_Slave_Disconnect(cl, obj);
	case MUIM_ZVNCA_Slave_RawKey:              return ZVNCA_Slave_RawKey(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_Slave_RawMouse:            return ZVNCA_Slave_RawMouse(cl, obj, (APTR)msg);
	case MUIM_ZVNCA_Slave_Toggle:              return ZVNCA_Slave_Toggle(cl, obj);
DISPATCHER_END
DISPATCHER_GATE(ZVNC_App)

/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/

STRPTR tabs[3];

BOOL MUI_Setup(void)
{
	tabs[0] = LS(MSG_TAB_SERVERS);
	tabs[1] = LS(MSG_TAB_SETTINGS);
	tabs[2] = NULL;

	if ((mdata.SBar = MUI_CreateCustomClass(NULL,MUIC_Area,NULL,sizeof (struct Data),DISPATCHER_REF(ZVNC_Sbar))))
	{
		mdata.SBar->mcc_Class->cl_ID = "ZVNC.sbar";
		
		if ((mdata.AppCl = MUI_CreateCustomClass(NULL, MUIC_Application, NULL, sizeof (struct AData), DISPATCHER_REF(ZVNC_App))))
		{
			if ((mdata.SLCl = MUI_CreateCustomClass(NULL, MUIC_List, NULL, sizeof (struct SLData), DISPATCHER_REF(ZVNC_ServerList))))
			{
				if ((mdata.KACl = MUI_CreateCustomClass(NULL, MUIC_Keyadjust, NULL, sizeof (struct KAData), DISPATCHER_REF(ZVNC_Keyadjust))))
				{
					Object *BT_Add, *BT_Remove, *BT_Connect;

					mdata.App = NewObject(mdata.AppCl->mcc_Class, NULL,

						SubWindow, mdata.W_Settings = WindowObject,
							MUIA_Window_Title, "ZNVC",
							MUIA_Window_Width, 480,
							MUIA_Window_Height, 480,
							WindowContents,
								VGroup,
									Child, mdata.T_Main = RegisterGroup(tabs),
										MUIA_CycleChain, TRUE,
										Child, VGroup,
											Child, mdata.L_Servers = NewObject(mdata.SLCl->mcc_Class, NULL,
												MUIA_CycleChain, TRUE,
												End,
											Child, HGroup,
												Child, BT_Connect = SimpleButton(LS(MSG_BUTTON_CONNECT)),
												Child, BT_Add = SimpleButton(LS(MSG_BUTTON_ADD)),
												Child, BT_Remove = SimpleButton(LS(MSG_BUTTON_REMOVE)),
												End,
										End,
										Child, VGroup,
											Child, RectangleObject, End,
											Child, ColGroup(2),
												Child, Label(LS(MSG_SETTINGS_QUICKCONNECT)),
												Child, mdata.K_QuickKey = NewObject(mdata.KACl->mcc_Class, NULL,
													MUIA_Keyadjust_AllowMultipleKeys, FALSE,
													MUIA_ObjectID, QUICKKEY_OBJECTID,
													MUIA_CycleChain, TRUE, TAG_DONE),
												Child, RectangleObject, MUIA_Weight, 0, End,
												Child, TextObject, MUIA_Font, MUIV_Font_Tiny, MUIA_Text_Contents,
													LS(MSG_SETTINGS_QUICKCONNECT_INFO), End,
												Child, Label(LS(MSG_SETTINGS_DISCONNECT)),
												Child, mdata.K_DisconnectKey = NewObject(mdata.KACl->mcc_Class, NULL,
													MUIA_Keyadjust_AllowMultipleKeys, FALSE,
													MUIA_ObjectID, DISCONNECTKEY_OBJECTID,
													MUIA_CycleChain, TRUE, TAG_DONE),
												Child, Label(LS(MSG_SETTINGS_TOGGLE)),
												Child, mdata.K_ToggleKey = NewObject(mdata.KACl->mcc_Class, NULL,
													MUIA_Keyadjust_AllowMultipleKeys, FALSE,
													MUIA_ObjectID, TOGGLEKEY_OBJECTID,
													MUIA_CycleChain, TRUE, TAG_DONE),
												End,
											Child, RectangleObject, End,
										End,
									End,
								End,
							End,

						End;

					if (mdata.App)
					{
						NEWLIST(&mdata.SBObjects);

						// install the plugin!
						ScreenbarControl(SBCT_InstallPlugin,(IPTR)mdata.SBar,TAG_DONE);
				
						// preset some defaults
						set(mdata.K_ToggleKey, MUIA_String_Contents, "control esc");
				
						DoMethod(mdata.App, MUIM_Application_Load, MUIV_Application_Load_ENV);
				
						set(mdata.W_Settings, MUIA_Window_Open, TRUE);
						DoMethod(mdata.W_Settings, MUIM_Notify, MUIA_Window_CloseRequest, TRUE, mdata.W_Settings, 3, MUIM_Set, MUIA_Window_Open, FALSE);
				
						DoMethod(mdata.App, MUIM_ZVNCA_SetupHotkeys);
				
						set(BT_Add, MUIA_CycleChain, TRUE);
						set(BT_Connect, MUIA_CycleChain, TRUE);
						set(BT_Remove, MUIA_CycleChain, TRUE);
				
						DoMethod(mdata.K_DisconnectKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_QuickKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_ToggleKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
				
						DoMethod(mdata.K_DisconnectKey, MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_QuickKey, MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_ToggleKey, MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);

						DoMethod(mdata.K_DisconnectKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_QuickKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);
						DoMethod(mdata.K_ToggleKey, MUIM_Notify, MUIA_Keyadjust_Key, MUIV_EveryTime, mdata.App, 1, MUIM_ZVNCA_SetupHotkeys);

						DoMethod(BT_Connect, MUIM_Notify, MUIA_Pressed, FALSE, mdata.App, 2, MUIM_ZVNCA_Connect, NULL);
						DoMethod(BT_Add, MUIM_Notify, MUIA_Pressed, FALSE, mdata.L_Servers, 3, MUIM_List_InsertSingle, 1, MUIV_List_Insert_Bottom);
						DoMethod(BT_Add, MUIM_Notify, MUIA_Pressed, FALSE, mdata.L_Servers, 3, MUIM_Set, MUIA_List_Active, MUIV_List_Active_Bottom);
						DoMethod(BT_Remove, MUIM_Notify, MUIA_Pressed, FALSE, mdata.L_Servers, 2, MUIM_List_Remove, MUIV_List_Remove_Active);
				
						mdata.Slave = MUI_NewObject(MUIC_Slave,
							MUIA_Slave_Application, mdata.App,
							MUIA_Slave_Object, mdata.App,
							TAG_DONE);
							
						if (mdata.Slave)
						{
							return TRUE;
						}
						
						MUI_DisposeObject(mdata.App);
						mdata.App = NULL;
					}
				
					MUI_DeleteCustomClass(mdata.KACl);
				}
			
				MUI_DeleteCustomClass(mdata.SLCl);
			}
		
			MUI_DeleteCustomClass(mdata.AppCl);
		}
		
		MUI_DeleteCustomClass(mdata.SBar);
		mdata.SBar = NULL;
	}
	
	return FALSE;
}

void MUI_Cleanup(void)
{
	MUI_DisposeObject(mdata.Slave);

	if (mdata.SBar) 
	{
		if (mdata.App) ScreenbarControl(SBCT_UninstallPlugin, (IPTR)mdata.SBar, TAG_DONE);
		MUI_DeleteCustomClass(mdata.SBar);
	}
	
	if (mdata.App)
	{
		DoMethod(mdata.App, MUIM_Application_Save, MUIV_Application_Save_ENV);
		DoMethod(mdata.App, MUIM_Application_Save, MUIV_Application_Save_ENVARC);

		MUI_DisposeObject(mdata.App);
	}
	
	if (mdata.Menustrip)
	{
		MUI_DisposeObject(mdata.Menustrip);
	}
	
	if (mdata.AppCl)
	{
		MUI_DeleteCustomClass(mdata.AppCl);
	}
	
	if (mdata.SLCl)
	{
		MUI_DeleteCustomClass(mdata.SLCl);
	}
	
	if (mdata.KACl)
	{
		MUI_DeleteCustomClass(mdata.KACl);
	}
}

ULONG MUI_Handle(ULONG sigs)
{
	if (mdata.App)
	{
		DoMethod(mdata.App, MUIM_Application_NewInput, &sigs);

		while (!sigs)
		{
			DoMethod(mdata.App, MUIM_Application_NewInput, &sigs);
		}
	}
	
	return sigs;
}

void MUI_Show(void)
{
	set(mdata.W_Settings, MUIA_Window_Open, TRUE);
}

void MUI_Hide(void)
{
	set(mdata.W_Settings, MUIA_Window_Open, FALSE);
}

void MUI_Key_Toggle(void)
{
	DEBUG_HK(dprintf("%s: called\n", __FUNCTION__));
	DoMethod(mdata.Slave, MUIM_Slave_Dispatch, MUIF_Slave_Delegate_ForceSlave, 1, MUIM_ZVNCA_Slave_Toggle);
}

void MUI_Key_Quick(void)
{
	struct SLEntry *e = NULL;
	
	DoMethod(mdata.L_Servers, MUIM_List_GetEntry, 0, &e);

	DoMethod(mdata.App, MUIM_ZVNCA_Connect, e);
}

void MUI_Key_Disconnect(void)
{
	DoMethod(mdata.Slave, MUIM_Slave_Dispatch, MUIF_Slave_Delegate_ForceSlave, 1, MUIM_ZVNCA_Slave_Disconnect);
}

int main(int argc, char **argv)
{
	struct Process *myproc = (struct Process*)FindTask(0);
	int retval = RETURN_ERROR;
	STRPTR buffer = NULL;
	BOOL have_shell;

	if (myproc->pr_CLI)
	{
		have_shell = TRUE;

		buffer = (STRPTR)AllocVec(256, MEMF_ANY);
		if (buffer == NULL ||
		    GetProgramName(buffer, 256) == DOSFALSE)
		{
			PrintFault(IoErr(), NULL);
			if (buffer)
				FreeVec(buffer);
			return RETURN_FAIL;
		}
		__programname = buffer;
	}
	else
	{
		struct WBStartup *wbs = (struct WBStartup *)argv;
		have_shell = FALSE;
		__programname = (STRPTR)wbs->sm_ArgList->wa_Name;
	}

	InitSemaphore(&mdata.sbLock);
	mdata.HostName[0] = 0;
	mdata.HotKey[0] = 0;

	if (init_stuff())
	{
		if (setup_newbroker(0))
		{
			if (MUI_Setup())
			{
				ULONG sigs = 0;

				MUI_Show();
				
				while (1)
				{
					ULONG muisigs = MUI_Handle(sigs);
					
					sigs = Wait(cxsig | muisigs | SIGBREAKF_CTRL_C);
				
					if (sigs & SIGBREAKF_CTRL_C) break;
				
					if (sigs & cxsig)
					{
						if (process_ix() == PIX_QUIT) break;
					}
				}
				
				MUI_Hide();
				MUI_Cleanup();
			}
		
			cleanup_newbroker();
		}
	
		close_stuff();
	}

	if (mdata.Icon) FreeDiskObject(mdata.Icon);

	if (buffer) FreeVec(buffer);
	
	return retval;
}

void vnc_stop(void)
{
	struct Task *me = FindTask(0);
	
	if (me == mdata.SlaveTask)
	{
		// stop eating input!
		RemoveCxObj(custom);
	}
	else if (mdata.active)
	{
		DoMethod(mdata.Slave, MUIM_Slave_Dispatch, 0, 1, MUIM_ZVNCA_Slave_Disconnect);
	}
}

